﻿#ifndef APTF_H
#define APTF_H

#include <QMainWindow>

#include "AaPreCompile.h" //KNotify

#include "iat_record_sample.h" //iat_record_sample
#include "WrongWordObject.h" //WrongWordObject

namespace Ui {
class AaaxSoundEmitter;
}

class AaaxSoundEmitter : public QMainWindow
{
    Q_OBJECT

public:
    void saveGeometry(); //!<保存几何属性。
    explicit AaaxSoundEmitter(QWidget *parent = 0);
    ~AaaxSoundEmitter();
    
private:
    void checkSupportedSampleRates(); //!<检查受支持的采样率。
    void initializeUi(); //!<对界面做一些初始化。
    void loadGeometry(); //!<载入几何属性。
    void loadSetting(); //!<载入设置信息。
    void saveSetting(); //!<设置对话框确认关闭，则保存设置信息。
    QMap<QString, WrongWordObject* > wrongWordNameObjectMap; //!<错字名字与错字信息对象之间的映射。
    QString keyWordString; //!<关键字字符串。
    void selectAudioInputDeviceByName(QString smartProxyHost); //!<按照名字选择对应的声音输入设备。
    void selectMostReasonableDeviceByName(); //!<选择最合理的输入设备名字。
    QMap<QString,QAudioDeviceInfo> audioInputDeviceNameInfoMap; //!<声音设备名字与设备信息的映射。
    void listAvailableAudioInputs(); //!<列出可用的音频输入设备。
    QNetworkAccessManager networkAccessManager; //!<网络访问管理器。
    void enableRecognizeButton(); //!<识别完毕，则重新启用识别按钮。
    iat_record_sample * iatRecordSample; //!<录音识别器。
    void connectSignals(); //!<连接信号槽。
    void initializeMemberObjects(); //!<初始化成员变量。
    Ui::AaaxSoundEmitter *ui;

private slots:
    void updateInputVolume(int newInputVolume); //!<更新输入音量的显示。
    void quit(); //!<退出。
    void startService(); //!<启动服务。
};

#endif // APTF_H
