﻿#ifndef AUDIOINPUT_H
#define AUDIOINPUT_H

#include <QMainWindow>

#include "AaPreCompile.h" //KNotify


#include "iat_record_sample.h" //main1
#include "PipeDevice.h" //PipeDevice


class AudioInput : public QObject
{
    Q_OBJECT

public:
    void recycle(); //!<回收。
    void start(); //!<开始录音。
    void stop(); //!<停止录音。
    int get_input_dev_num(); //!<获取输入设备个数。
    static AudioInput * singleInstance(); //!<获取单实例。
    
    ~AudioInput();
    
    bool getRecording() const;
    void setRecording(bool value);
    
    recorder *getRecordStruct() const;
    
    QAudioDeviceInfo getAudioDevice() const;
    void setAudioDevice(const QAudioDeviceInfo &value);
    
    qreal getVolume() const;
    void setVolume(const qreal &value);
    
    QString getReceiverIp() const;
    void setReceiverIp(const QString &value);
    
private:
    QString receiverIp; //!<接收方的地址。
    QUdpSocket *udpSocket; //!<发送数据时使用的UDP套接字。
    qreal volume; //!<录音音量。
    QAudioDeviceInfo audioDevice; //!<输入设备。
    QQueue<QAudioInput*> audioRecycleQueue; //!<音频输入设备回收队列。
    QQueue<PipeDevice*> pipeDeviceRecycleQueue; //!<管道设备回收队列。
    PipeDevice * pipeDevice=nullptr; //!<管道设备。
    struct recorder * recordStruct=nullptr; //!<录音器结构体。
    bool recording=false; //!<是否正在录音。
    static AudioInput * mInstance; //!<单实例。
    explicit AudioInput(QWidget *parent = 0);
    QAudioInput * audio=nullptr; //!<音频输入资源。
    void connectSignals(); //!<连接信号槽。
    void initializeMemberObjects(); //!<初始化成员变量。

private slots:
    void quit(); //!<退出。
    
signals:
    void logInfo(QString logContent) const; //!<需要输出日志。
};

#endif // APTF_H
