﻿#ifndef PIPEDEVICE_H
#define PIPEDEVICE_H

#include "AaPreCompile.h" //KNotify


#include "iat_record_sample.h" //main1

class PipeDevice : public QIODevice
{
    Q_OBJECT

public:
    void stopPipe(); //!<停止管道动作。
    void startPipe(); //!<开始管道动作。
    qint64 writeData(const char *data, qint64 len);
    qint64 readData(char *data, qint64 maxlen);
    int get_input_dev_num(); //!<获取输入设备个数。
    static PipeDevice * singleInstance(); //!<获取单实例。
    explicit PipeDevice(QObject *parent = 0);
    bool getRecording() const;
    void setRecording(bool value);
    QUdpSocket *getUdpSocket() const;
    void setUdpSocket(QUdpSocket *value);

    QString getReceiverIp() const;
    void setReceiverIp(const QString &value);
    
private:
    QString receiverIp; //!<接收方的地址。
    OpusEncoder * enc; //!<Opus编码器。
    int sentPackageAmount=0; //!<已发送数据包个数计数。
    void initializeMemberObjects(); //!<初始化成员变量。
    const qint32 SendBufferLength=3840; //!<发送缓冲区长度。
    QUdpSocket *udpSocket; //!<发送数据时使用的UDP套接字。
    QByteArray rawBuffer; //!<尚未编码的数据的缓冲区。
    const QString multicastAddress="239.173.40.5"; //!<组播地址。
    bool pipeEnabled=false; //!<是否启用管道。
    const quint16 MulticastPort=10493; //!<组播组的端口号。
    bool recording=false; //!<是否正在录音。
    static PipeDevice * mInstance; //!<单实例。
    QFile destinationFile;
    void connectSignals(); //!<连接信号槽。

private slots:
    void quit(); //!<退出。
}; //class PipeDevice : public QIODevice

#endif // APTF_H
