﻿#ifndef WRONGWORDOBJECT_H
#define WRONGWORDOBJECT_H

#include "AaPreCompile.h" //QString

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

class WrongWordObject:public QObject
{
    Q_OBJECT
    
private:
    QString mWrongWordName; //!<错字名字。
    QMap<QString, int> rightWordCountMap; //!<正确字的计数映射。
    
    QQueue<QString> paragraphQueue; //!<段落队列。
    void connectSignals(); //!<连接信号。
    QString currentTtsFileName; //!<当前的语音合成文件名。对应着一个段落。
    void processParagraphFinished(); //!<合成完毕，则报告段落合成完毕。
    
public:
    
    void merge(WrongWordObject* wrongWordNameObjectMapwrongWord); //!<从另一个错字信息对象中合并内容。
    
    WrongWordObject(QString wrongWordName, QVariant wrongWordVariant); //!<构造函数。
    
    QMap<QString, int> getRightWordCountMap() const;
    void setRightWordCountMap(const QMap<QString, int> &value);
    
signals:
    void logInfo(QString logContent) const; //!<需要输出日志。
    void ttsFinished(); //!<信号，语音合成完毕。
    void paragraphFinished(QString fileName); //!<合成完毕，则报告段落合成完毕。
};

#endif
