
#include "SbPreCompile.h" //AudioInput

#include "speech_recognizer.h"
#include "iat_record_sample.h" //iat_record_sample
#include "linuxrec.h" //start_record
#include "AudioInput.h" //AudioInput

#define FRAME_LEN	640 
#define	BUFFER_SIZE	4096

void iat_record_sample::show_result(char *string, char is_over)
{
	printf("\rResult: [ %s ]", string);
	if(is_over) //全部内容结束。
    {
        	putchar('\n');
    } //if(is_over) //全部内容结束。
	
    emit gotResult(string, is_over); //发射信号，收到结果。
}

iat_record_sample * iat_record_sample::mInstance=nullptr; //!<单实例。

/*!
 * \brief iat_record_sample::singleInstance 获取单实例。
 * \return 单实例。
 */
iat_record_sample * iat_record_sample::singleInstance()
{
    if (mInstance==nullptr) //单实例尚不存在。
    {
        mInstance=new iat_record_sample; //创建实例。
    } //if (mInstance==nullptr) //单实例尚不存在。
    
    
    return mInstance;
} //iat_record_sample * iat_record_sample::singleInstance()

/*!
 * \brief iat_record_sample::on_result 得到结果。
 * \param result 结果字符串。
 * \param is_last 是否是最后一部分结果。
 */
void iat_record_sample::on_result(const char *result, char is_last)
{
    mInstance->processResult(result,is_last); //处理结果。
    
}

/*!
 * \brief iat_record_sample::processResult 处理结果。
 * \param result 结果字符串。
 * \param is_last 是否是最后一部分结果。
 */
void iat_record_sample::processResult(const char * result, char is_last)
{
    if (result) {
		size_t left = g_buffersize - 1 - strlen(g_result);
		size_t size = strlen(result);
		if (left < size) {
			g_result = (char*)realloc(g_result, g_buffersize + BUFFER_SIZE);
			if (g_result)
				g_buffersize += BUFFER_SIZE;
			else {
                cout << __FILE__ << ", " << __LINE__ << ", " << __func__  <<  ", mem alloc failed" << endl;
                
				return;
			}
		}
		strncat(g_result, result, size);
		show_result(g_result, is_last);
	}
    
} //void iat_record_sample::processResult(const char * result, char is_last)

/*!
 * \brief iat_record_sample::processSpeechBegin 处理说话开始。
 */
void iat_record_sample::processSpeechBegin()
{
    if (g_result)
	{
		free(g_result);
	}
	g_result = (char*)malloc(BUFFER_SIZE);
	g_buffersize = BUFFER_SIZE;
	memset(g_result, 0, g_buffersize);
} //void iat_record_sample::processSpeechBegin()

/*!
 * \brief iat_record_sample::on_speech_begin 说话开始。
 */
void iat_record_sample::on_speech_begin()
{
    mInstance->processSpeechBegin(); //处理说话开始。
    
}

/* main thread: start/stop record ; query the result of recgonization.
 * record thread: record callback(data write)
 * helper thread: ui(keystroke detection)
 */
int iat_record_sample::main1()
{
    //启动录音及识别过程：

    int ret=0;
    
    AudioInput * audioInput=AudioInput::singleInstance(); //获取音频输入对象。
    
    audioInput->recycle(); //回收。
    
    audioInput->start(); //开始录音。
    
	
	return ret;
} //int iat_record_sample::main1()
