#ifndef IAT_RECORD_SAMPLE_H
#define IAT_RECORD_SAMPLE_H


/*
* 语音听写(iFly Auto Transform)技术能够实时地将语音转换成对应的文字。
*/

#include "SbPreCompile.h" //Q_OBJECT

#include <stdlib.h>
//#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "speech_recognizer.h"

#define FRAME_LEN	640 
#define	BUFFER_SIZE	4096

class iat_record_sample:public QObject
{
    Q_OBJECT
    
private:
    char *g_result=nullptr ; //!<结果字符串。
    
    struct speech_rec iat; //!<识别器。
    void processResult(const char * result, char is_last); //!<处理结果。
    static iat_record_sample * mInstance; //!<单实例。
    void processSpeechBegin(); //!<处理说话开始。
    
public:
    static iat_record_sample * singleInstance(); //!<获取单实例。
    
    /* Upload User words */
    void show_result(char *string, char is_over);
    
    
    unsigned int g_buffersize ;
    
    static void on_result(const char *result, char is_last); //!<得到结果。
     
    static void on_speech_begin(); //!<说话开始。
    
    /* main thread: start/stop record ; query the result of recgonization.
     * record thread: record callback(data write)
     * helper thread: ui(keystroke detection)
     */
    int main1();
    
signals:
    void logInfo(QString logContent); //!<需要输出日志。
    void recognizeFinished(); //!<识别结束。
    void gotResult(char * string, char is_over); //!<信号，收到结果。
};




#endif
