/*
@file
@brief  record demo for linux

@author		taozhang9
@date		2016/05/27
*/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>

#include <signal.h>
#include <sys/stat.h>
#include <pthread.h>
#include "formats.h"
#include "linuxrec.h"
#include "AudioInput.h" //AudioInput


#define DBG_ON 1

#if DBG_ON
#define dbg  printf
#else
#define dbg
#endif


/* Do not change the sequence */
enum {
	RECORD_STATE_CREATED,	/* Init		*/
	RECORD_STATE_CLOSING,
	RECORD_STATE_READY,		/* Opened	*/
	RECORD_STATE_STOPPING,	/* During Stop	*/
	RECORD_STATE_RECORDING,	/* Started	*/
};

#define SAMPLE_RATE  16000
#define SAMPLE_BIT_SIZE 16
#define FRAME_CNT   10
//#define BUF_COUNT   1
#define DEF_BUFF_TIME  500000
#define DEF_PERIOD_TIME 100000

#define DEFAULT_FORMAT		\
{\
	WAVE_FORMAT_PCM,	\
	1,			\
	16000,			\
	32000,			\
	2,			\
	16,			\
	sizeof(WAVEFORMATEX)	\
}



static int stop_record_internal()
{
    AudioInput * audioInput=AudioInput::singleInstance(); //获取音频输入对象。
    
    audioInput->stop(); //停止录音。
    
	return 0;
}

int stop_record()
{
	int ret;

	ret = stop_record_internal();

    return ret;
}

int is_record_stopped()
{
    AudioInput * audioInput=AudioInput::singleInstance(); //获取音频输入对象。
    

    
    bool isRecording=    audioInput->getRecording(); //是否正在录音。
    
    bool result=(!isRecording); //结果。
    
	return result;
}
